--obj
open = true;
count = false;
countUp = false;
chooseScreen = true;
first = true;
numPad = false;
play3 = true;
play2 = true;
play1 = true;
play0 = true;
h = screen.height();
w = screen.width();
black = color.new(0,0,0);
orange = color.new(200,100,0);
o = os.time();
s = 0;
charAt = 1;
writeM = "";
writeS = "";
writeF = "__:__";
writeGesS = 0;
full = false;
--images
data = image.setresource("data.bin");
resetBtn = image.load("data/resetBtn.png");
startBtn = image.load("data/startBtn.png");
stopBtn = image.load("data/stopBtn.png");
startScreen = image.load("data/startScreen.png");
numPadImage = image.load("data/numPad.png");
--sounds
shoSound = wav.load("short.wav");
endSound = wav.load("end.wav");
--functions
function makeScreen(a)
    screen.fillrect(0,0,w,h,black);
    resetBtn:draw(0,180);
    if count then
        stopBtn:draw(200,180);
	else
		startBtn:draw(200,180);
	end
	if numPad then
	    numPadImage:draw(0,0)
	end
    text.size(40);
    text.color(orange);
    text.draw(0,80,a,"center",400);
    screen.update();
end
function reset()	
	if countDown then
		if full then
			count = false;
			s = 0;
			writeM = "";
			writeS = "";
			writeF = "__:__";
			charAt = 1;
			first = true;
		end 
	else
		count = false;
		s = 0;			
		makeScreen("00:00");			
	end
end
function startStop()
	if count then
		count = false;
		s = o - os.time();
		makeScreen(makeCountString());
	else
	    if countDown == false then
			count = true;
		end
		if full then
			count = true;
		end
		o = os.time()+s;
  		play3 = true;
		play2 = true;
		play1 = true;
		play0 = true;
	end
end
function makeCountString()
	if countDown then
	    activeSeconds = o+writeGesS - os.time();
	    if activeSeconds == 3 and play3 then
			shoSound:play();
	    	play3 = false;
		end
		if activeSeconds == 2 and play2 then
			shoSound:play();
			play2 = false;
		end
		if activeSeconds == 1 and play1 then
   			shoSound:play();
			play1 = false;
		end
		if activeSeconds == 0 and play0 then
			endSound:play();
			play0 = false;
			count = false;
		end	
	else
		activeSeconds = os.time() - o;
	end
	splitMin = math.floor(activeSeconds / 60);
	splitSeconds = activeSeconds - (splitMin * 60);
	if string.len(splitMin) == 1 then
		splitMin = string.format("0%d",splitMin);
	end
	if string.len(splitSeconds) == 1 then
		splitSeconds = string.format("0%d",splitSeconds);
	end
	stringOut = string.format("%s:%s",splitMin,splitSeconds);
	return stringOut;
end
function withinRegion(x, y, rx, ry, w, h)
	if x >= rx and x <= (rx + w) and y >= ry and y <= (ry + h) then
		return true;
	else
		return false;
	end;
end;
function round(n)
	a = math.floor(n)+0.5;
	if(n < a)then
	    return math.floor(n)
	else
		return math.ceil(n)
	end
end
function getNumPad(x,y)
    if withinRegion(x,y,0,0,50,40) then
		return 7;
	elseif withinRegion(x,y,50,0,50,40) then
	    return 8;
	elseif withinRegion(x,y,100,0,50,40) then
		return 9;
	elseif withinRegion(x,y,0,40,50,40) then
	    return 4;
	elseif withinRegion(x,y,50,40,50,40) then
	    return 5
	elseif withinRegion(x,y,100,40,50,40) then
	    return 6
	elseif withinRegion(x,y,0,80,50,40) then
	    return 1
	elseif withinRegion(x,y,50,80,50,40) then
	    return 2
	elseif withinRegion(x,y,100,80,50,40) then
	    return 3
	elseif withinRegion(x,y,0,120,100,40) then
	    return 999
	elseif withinRegion(x,y,100,120,50,40) then
	    return 0
	else
		return -1;
	end
end
function writeNumPad(a)
	full = false;
	if a >= 0 then 
		if a == 999 then
			writeM = "";
			writeS = "";
			writeF = "__:__";
			charAt = 1;
		else
			if charAt == 1 then
   				writeM = a;
	   			print(writeM)
   				print(writeS)
			else
				if charAt == 2 then
					writeM = string.format("%s%d",writeM,a);
					print(writeM)
   					print(writeS)
        		else
					if charAt == 3 then
						if a > 5 then
							a = 5
						end
						writeS = a;
						print(writeM)
   						print(writeS)
					else
						writeS = string.format("%s%d",writeS,a);
						print(writeM)
   						print(writeS)
					end
				end
			end
			if charAt == 1 then
				a = string.format("%s_:__",writeM);
				print(a);
			else
				if charAt == 2 then
		    		a = string.format("%s:__",writeM);
		    		print(a);
				else
					if charAt == 3 then
					    a = string.format("%s:%s_",writeM,writeS);
					    print(a);
					else
		    			a = string.format("%s:%s",writeM,writeS);
			    		print(a);
			    		full = true;
					end
				end
			end
			charAt = charAt + 1;
			print(charAt);
			writeF = a;
			end
		if full then
			writeGesS = writeM * 60 + writeS;
		end
	end
	return full;
end
function btnCheck()
	if control.read() == 1 then
		if control.isTouch() == 1 then
			--if touch.event() == 1 then
				if touch.click() == 1 then
					x,y = touch.pos();
					if numPad then
					    if writeNumPad(getNumPad(x,y)) then
					        first = false;
					        numPad = false;
						end
						makeScreen(writeF);
					end
					if chooseScreen then
						if x < 200 then
						    countDown = false
						    s = 0;
						else
						    countDown = true
						    s = 0;
						end
						chooseScreen = false;
						makeScreen("00:00");
					else
						if withinRegion(x,y, 0,180,200,60) then
							reset();
							print("Reset");
						end
						if withinRegion(x,y,200,180,200,60) then
							startStop();
							print("Start/Stop");
						end
					end
				end
			--end
		end
		if control.isButton() == 1 then
			if button.home() == 1 then
				if button.click() == 1 then
					if chooseScreen then
						open = false
					else
 				        count = false;
      					chooseScreen = true;
						first = true;
						numPad = false;
					end
				end
			end
			if button.power() == 1 then
				if button.click() == 1 then
     				if chooseScreen then
						open = false
					else
 				        count = false;
      					chooseScreen = true;
						first = true;
						numPad = false;
					end
				end
			end
		end			
	else 
		os.sleep(10)
	end	
end
function outro()
	white = color.new(255,255,255);
	screen.fillrect(0,0,w,h,black);
	text.size(20);
    text.color(white);
    text.draw(0,80,"made by","center",400);
    screen.update();
    os.sleep(50);
    screen.fillrect(0,0,w,h,black);
	text.size(40);
    text.color(white);
    text.draw(0,140,"M","center",400);
    screen.update();
    os.sleep(25);
    screen.fillrect(0,0,w,h,black);
	text.size(40);
    text.color(white);
    text.draw(0,140,"Mo","center",400);
    screen.update();
    os.sleep(25);
    screen.fillrect(0,0,w,h,black);
	text.size(40);
    text.color(white);
    text.draw(0,140,"Moe","center",400);
    screen.update();
    os.sleep(100);
    resetBtn:close();
	startBtn:close()
	stopBtn:close()
	startScreen:close()
	numPadImage:close()
	shoSound:close()
	endSound:close()
end
--Start
while open do
	if first then
		if chooseScreen then
		   charAt = 1;
			writeM = "";
			writeS = "";
			writeF = "__:__";
			writeGesS = 0;
			screen.fillrect(0,0,w,h,black);
			startScreen:draw(0,0);
			screen.update();
		elseif countDown then
			numPad = true;
			makeScreen(writeF);
		end
	end
	if count then	
		makeScreen(makeCountString());
	else os.sleep(10)
	end
	btnCheck();
end
--Outro
outro();


